commit 85f466ed0d4da336fadd01e43d764326cbabdecb
Author: Patrick Palka <ppalka@redhat.com>
Date:   Thu May 15 17:07:53 2025

    c++: unifying specializations of non-primary tmpls [PR120161]
    
    Here unification of P=Wrap<int>::type, A=Wrap<long>::type wrongly
    succeeds ever since r14-4112 which made the RECORD_TYPE case of unify
    no longer recurse into template arguments for non-primary templates
    (since they're a non-deduced context) and so the int/long mismatch that
    makes the two types distinct goes unnoticed.
    
    In the case of (comparing specializations of) a non-primary template,
    unify should still go on to compare the types directly before returning
    success.
    
            PR c++/120161
    
    gcc/cp/ChangeLog:
    
            * pt.cc (unify) <case RECORD_TYPE>: When comparing specializations
            of a non-primary template, still perform a type comparison.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/template/unify13.C: New test.
    
    Reviewed-by: Jason Merrill <jason@redhat.com>
    (cherry picked from commit 0c430503f2849ebb20105695b8ad40d43d797c7b)

diff --git a/gcc/cp/pt.cc b/gcc/cp/pt.cc
index 65fa85b0610..fb9b407c453 100644
--- a/gcc/cp/pt.cc
+++ b/gcc/cp/pt.cc
@@ -25299,10 +25299,10 @@ unify (tree tparms, tree targs, tree parm, tree arg, int strict,
 			  INNERMOST_TEMPLATE_ARGS (CLASSTYPE_TI_ARGS (parm)),
 			  INNERMOST_TEMPLATE_ARGS (CLASSTYPE_TI_ARGS (t)),
 			  UNIFY_ALLOW_NONE, explain_p);
-	  else
-	    return unify_success (explain_p);
+	  gcc_checking_assert (t == arg);
 	}
-      else if (!same_type_ignoring_top_level_qualifiers_p (parm, arg))
+
+      if (!same_type_ignoring_top_level_qualifiers_p (parm, arg))
 	return unify_type_mismatch (explain_p, parm, arg);
       return unify_success (explain_p);
 
